local addonName, TF = ...

local TradeFill = LibStub("AceAddon-3.0"):GetAddon(addonName)
local Loc = LibStub("AceLocale-3.0"):GetLocale(addonName)

function TradeFill:RemoveItem(item)
    for tradeSlot = 1, MAX_TRADABLE_ITEMS do
        if GetTradePlayerItemLink(tradeSlot) ~= nil then
            local name, _, _, _, _, _ = GetTradePlayerItemInfo(tradeSlot)
            local id, _, _, _, _, _, _ = GetItemInfoInstant(GetTradePlayerItemLink(tradeSlot))

            if name ~= nil and id == item.id then
                ClearCursor()
                ClickTradeButton(tradeSlot)
                ClearCursor()
                break
            end
        end
    end
end

function TradeFill:AutoFill(item, position)
    local linkIcon = item.link .. " |T" .. GetItemIcon(item.id) .. ":0|t"

    if next(TF.inventory) == nil then
        TradeFill:Message(Loc["MESSAGE_NO_ITEM"], linkIcon, "", false)
        return
    end

    if position == nil then
        TradeFill:Message(Loc["MESSAGE_FULL"])
        return
    else
        local stack = TradeFill.db.profile.setting.full

        for key, slot in pairs(TF.inventory) do
            local locked = C_Container.GetContainerItemInfo(slot.bag, slot.slot)

            if slot.bound == true then
                TradeFill:Message(Loc["MESSAGE_SOULBOUND"], linkIcon, "", false)
                return
            end

            if stack then
                if slot.itemName == item.name and locked.isLocked == false and slot.count == item.stack then
                    ClearCursor()
                    C_Container.PickupContainerItem(slot.bag, slot.slot)
                    ClickTradeButton(position)
                    ClearCursor()
                    break
                end
            else
                if slot.itemName == item.name and locked.isLocked == false then
                    ClearCursor()
                    C_Container.PickupContainerItem(slot.bag, slot.slot)
                    ClickTradeButton(position)
                    ClearCursor()
                    break
                end
            end

            if #TF.inventory == key then
                if stack then
                    TradeFill:Message(Loc["MESSAGE_NO_FULL_STACK"], linkIcon, "", false)
                    return
                else
                    TradeFill:Message(Loc["MESSAGE_NO_STACK"], linkIcon, "", false)
                    return
                end
            end
        end
    end
end